package CustomLinks;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.HTMLBlock;
import quadbase.reportdesigner.util.IExportConstants;
import quadbase.reportdesigner.util.IHTMLLinksProvider;

public class CustomLinks extends Applet implements IHTMLLinksProvider {

	static final long serialVersionUID = 1;

	public static void main(java.lang.String[] args) {

		try {

			CustomLinks report = new CustomLinks();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", report.doCustomLinks(frame));
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {

			ex.printStackTrace();

		}

	}

	@Override
	public void init() {

		setLayout(new BorderLayout());
		add("Center", doCustomLinks(this));

	}

	Component doCustomLinks(Object parent) {
		QbReport.setEspressManagerUsed(false);
		QbReport report = new QbReport(parent, "CustomLinks.rpt");
		report.setHTMLLinksProvider(this);
		QbReport.setExportToMultiPages(true);

		try
		{
			report.export(IExportConstants.DHTML, "CustomLinks.html");
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return (new Viewer().getComponent(report));

	}

	public HTMLBlock getLinksForDHTML(int cPage, int tPage, String prefix, boolean top)
	{

		String linksText = "<CENTER><font face=\\\"verdana\\\" size=\\\"2\\\">" +

				"<a href=\\\"" + HTMLBlock.getFirstFileName(prefix) + "\\\">FIRST</a> | ";
		if (cPage <= 2) {
			linksText += "<a href=\\\"" + HTMLBlock.getFirstFileName(prefix) + "\\\">PREV</a> | "
					+ "<a href=\\\"" + HTMLBlock.getNextFileName(cPage, tPage, prefix)
					+ "\\\">NEXT</a> | " + "<a href=\\\"" + HTMLBlock.getLastFileName(prefix)
					+ "\\\">LAST</a> [" + "<a href=\\\""
					+ HTMLBlock.getCurrentFileName(cPage, tPage, prefix)
					+ "?x=x\\\" target=\\\"print\\\">Print Version</a>]" + "</font></CENTER>";
		} else {
			linksText += "<a href=\\\"" + HTMLBlock.getPreviousFileName(cPage, tPage, prefix)
					+ "\\\">PREV</a> | " + "<a href=\\\""
					+ HTMLBlock.getNextFileName(cPage, tPage, prefix) + "\\\">NEXT</a> | "
					+ "<a href=\\\"" + HTMLBlock.getLastFileName(prefix) + "\\\">LAST</a> ["
					+ "<a href=\\\"" + HTMLBlock.getCurrentFileName(cPage, tPage, prefix)
					+ "?x=x\\\" target=\\\"print\\\">Print Version</a>]" + "</font></CENTER>";
		}

		String text = "<SCRIPT>\n" + "document.write(\"" + linksText + "\");\n" + "</SCRIPT>";
		return new HTMLBlock(text, 100);

	}

	public HTMLBlock getLinksForHTML(int cPage, int tPage, String prefix, boolean top)
	{
		return getLinksForDHTML(cPage, tPage, prefix, top);
	}

	public HTMLBlock getTOCLinkForDHTML(int cPage, int tPage, String body) {
		return null;
	}
}